class Coordinate {
  x;
  y;
  constructor(x, y) {
    this.x = Number(x);
    this.y = Number(y);
  }
  copy(coordinate) {
    this.x = Number(coordinate.x);
    this.y = Number(coordinate.y);
  }
  distance(coordinate) {
    return Math.sqrt((this.x - coordinate.x)**2 
                   + (this.y - coordinate.y)**2);
  }
  add(coordinate) {
    this.x = Number(this.x) + Number(coordinate.x);
    this.y = Number(this.y) + Number(coordinate.y);
  }
  subtract(coordinate) {
    this.x = Number(this.x) - Number(coordinate.x);
    this.y = Number(this.y) - Number(coordinate.y);
  }
  multiply(multiplier) {
    this.x = Number(this.x * multiplier);
    this.y = Number(this.y * multiplier);
  }
  equal(coord) {
    if (Math.abs(this.x - coord.x) < ERROR_TOLERANCE && Math.abs(this.y - coord.y) < ERROR_TOLERANCE)
      return true;
    return false;
  }
  set x(value) {
    this._x = Number(value);
  }
  set y(value) {
    this._y = Number(value);
  }
  toString() {
    return "(" + this.x + ", " + this.y + ")";
  }
}
