/*######################### Class #########################*/
class FragmentSize {
  #minx;
	#maxx;
	#miny;
	#maxy;
	constructor(size) {
    this.minx = size[0][0];
    this.maxx = size[0][1];
    this.miny = size[1][0];
    this.maxy = size[1][1];
  }
	copy(fragSize) {
    this.minx = Number(fragSize.minx);
		this.maxx = Number(fragSize.maxx);
    this.miny = Number(fragSize.miny);
    this.maxy = Number(fragSize.maxy);
  }
	get minx() {
		return this._minx
	}
	get maxx() {
		return this._maxx
	}
	get miny() {
		return this._miny
	}
	get maxy() {
		return this._maxy
	}
  set minx(value) {
		this._minx = value
	}
	set maxx(value) {
		this._maxx = value
	}
	set miny(value) {
		this._miny = value
	}
	set maxy(value) {
		this._maxy = value
	}
	toString() {
		return "(" + this.minx + ", " + this.maxx + "), (" +  this.miny + ", " + this.maxy + ")";
	}
}
/*######################### Print function #########################*/
function printFragSize() {
  //alert("fragSize: " + fragSize.toString());
	console.log("fragSize: " + fragSize.toString());
}

/*######################### Handlers #########################*/
function getXSliderValues(){
  var xValuesArr = xSlider.noUiSlider.get();
  fragSize.minx = xValuesArr[0];
  fragSize.maxx = xValuesArr[1];
  //printFragSize();
  stateHandler();
}
function getYSliderValues(){
  var yValuesArr = ySlider.noUiSlider.get();
  fragSize.miny = yValuesArr[0];
  fragSize.maxy = yValuesArr[1];
  //printFragSize();
  stateHandler();
}
function getRightXSliderValues(){
  var xValuesArr = right_xSlider.noUiSlider.get();
  right_fragSize.minx = xValuesArr[0];
  right_fragSize.maxx = xValuesArr[1];
  //printFragSize();
  stateHandler();
}
function getRightYSliderValues(){
  var yValuesArr = right_ySlider.noUiSlider.get();
  right_fragSize.miny = yValuesArr[0];
  right_fragSize.maxy = yValuesArr[1];
  //printFragSize();
  stateHandler();
}
/*######################### Setter #########################*/
function setNewFragmentSize(newFragSize) { 
  fragSize.copy(newFragSize);
  
  xSlider.noUiSlider.set([fragSize.minx, fragSize.maxx]);
  ySlider.noUiSlider.set([fragSize.miny, fragSize.maxy]);
}
function setNewRightFragmentSize(newFragSize) { 
  right_fragSize.copy(newFragSize);
  
  right_xSlider.noUiSlider.set([right_fragSize.minx, right_fragSize.maxx]);
  right_ySlider.noUiSlider.set([right_fragSize.miny, right_fragSize.maxy]);
}
/*######################### Declaring global variable fragSize #########################*/
const fragSize = new FragmentSize(SLIDER_DEFAULT_RANGE);
const right_fragSize = new FragmentSize(SLIDER_DEFAULT_RANGE);